/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.convert.PostgresJSONGsonBinding;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.CellEqualizerConfigurationRecord;
import com.google.gson.JsonElement;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CellEqualizerConfiguration extends TableImpl<CellEqualizerConfigurationRecord> {

	private static final long serialVersionUID = 1298625066;

	/**
	 * The reference instance of <code>public.cell_equalizer_configuration</code>
	 */
	public static final CellEqualizerConfiguration CELL_EQUALIZER_CONFIGURATION = new CellEqualizerConfiguration();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<CellEqualizerConfigurationRecord> getRecordType() {
		return CellEqualizerConfigurationRecord.class;
	}

	/**
	 * The column <code>public.cell_equalizer_configuration.id</code>.
	 */
	public final TableField<CellEqualizerConfigurationRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.cell_equalizer_configuration.server_id</code>.
	 */
	public final TableField<CellEqualizerConfigurationRecord, Long> SERVER_ID = createField("server_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.cell_equalizer_configuration.class_name</code>.
	 */
	public final TableField<CellEqualizerConfigurationRecord, String> CLASS_NAME = createField("class_name", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.cell_equalizer_configuration.configuration</code>.
	 */
	public final TableField<CellEqualizerConfigurationRecord, JsonElement> CONFIGURATION = createField("configuration", org.jooq.impl.SQLDataType.OTHER, this, "", new PostgresJSONGsonBinding());

	/**
	 * Create a <code>public.cell_equalizer_configuration</code> table reference
	 */
	public CellEqualizerConfiguration() {
		this("cell_equalizer_configuration", null);
	}

	/**
	 * Create an aliased <code>public.cell_equalizer_configuration</code> table reference
	 */
	public CellEqualizerConfiguration(String alias) {
		this(alias, CELL_EQUALIZER_CONFIGURATION);
	}

	private CellEqualizerConfiguration(String alias, Table<CellEqualizerConfigurationRecord> aliased) {
		this(alias, aliased, null);
	}

	private CellEqualizerConfiguration(String alias, Table<CellEqualizerConfigurationRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<CellEqualizerConfigurationRecord, Long> getIdentity() {
		return Keys.IDENTITY_CELL_EQUALIZER_CONFIGURATION;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<CellEqualizerConfigurationRecord> getPrimaryKey() {
		return Keys.CELL_EQUALIZER_CONFIGURATION_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<CellEqualizerConfigurationRecord>> getKeys() {
		return Arrays.<UniqueKey<CellEqualizerConfigurationRecord>>asList(Keys.CELL_EQUALIZER_CONFIGURATION_PKEY, Keys.CELL_EQUALIZER_CONFIGURATION_SERVER_ID_KEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public CellEqualizerConfiguration as(String alias) {
		return new CellEqualizerConfiguration(alias, this);
	}

	/**
	 * Rename this table
	 */
	public CellEqualizerConfiguration rename(String name) {
		return new CellEqualizerConfiguration(name, null);
	}
}
